IRremoteESP8266: IRDaikin152 Class Reference

IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRDaikin152 Class Reference

Class for handling detailed Daikin 152-bit A/C messages. More...

`#include <ir_Daikin.h>`

Collaboration diagram for IRDaikin152:
[legend]

## Public Member Functions

| IRDaikin152 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kDaikin152DefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t new_code[])
| Set the internal state from a valid code for this protocol. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t fan)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setSwingV (const bool on)
| Set the Vertical Swing mode of the A/C. More...
bool | getSwingV (void) const
| Get the Vertical Swing mode of the A/C. More...
bool | getQuiet (void) const
| Get the Quiet mode status of the A/C. More...
void | setQuiet (const bool on)
| Set the Quiet mode of the A/C. More...
bool | getPowerful (void) const
| Get the Powerful (Turbo) mode of the A/C. More...
void | setPowerful (const bool on)
| Set the Powerful (Turbo) mode of the A/C. More...
void | setSensor (const bool on)
| Set the Sensor mode of the A/C. More...
bool | getSensor (void) const
| Get the Sensor mode of the A/C. More...
void | setEcono (const bool on)
| Set the Economy mode of the A/C. More...
bool | getEcono (void) const
| Get the Economical mode of the A/C. More...
void | setComfort (const bool on)
| Set the Comfort mode of the A/C. More...
bool | getComfort (void) const
| Get the Comfort mode of the A/C. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static bool | validChecksum (uint8_t state[], const uint16_t length=kDaikin152StateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...

## Private Member Functions

void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | checksum (void)
| Calculate and set the checksum values for the internal state. More...

## Private Attributes

IRsend | _irsend
| instance of the IR send class More...
Daikin152Protocol | _

## Detailed Description

Class for handling detailed Daikin 152-bit A/C messages.

## Constructor & Destructor Documentation

## ◆ IRDaikin152()

IRDaikin152::IRDaikin152 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRDaikin152::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calibrate()

int8_t IRDaikin152::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRDaikin152::checksum | ( | void |  | ) |

private

Calculate and set the checksum values for the internal state.

## ◆ convertFan()

uint8_t IRDaikin152::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRDaikin152::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getComfort()

bool IRDaikin152::getComfort | ( | void |  | ) | const

Get the Comfort mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getEcono()

bool IRDaikin152::getEcono | ( | void |  | ) | const

Get the Economical mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getFan()

uint8_t IRDaikin152::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## ◆ getMode()

uint8_t IRDaikin152::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getPower()

bool IRDaikin152::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getPowerful()

bool IRDaikin152::getPowerful | ( | void |  | ) | const

Get the Powerful (Turbo) mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getQuiet()

bool IRDaikin152::getQuiet | ( | void |  | ) | const

Get the Quiet mode status of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint8_t * IRDaikin152::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## ◆ getSensor()

bool IRDaikin152::getSensor | ( | void |  | ) | const

Get the Sensor mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingV()

bool IRDaikin152::getSwingV | ( | void |  | ) | const

Get the Vertical Swing mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRDaikin152::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ off()

void IRDaikin152::off | ( | void |  | ) |

Change the power setting to Off.

## ◆ on()

void IRDaikin152::on | ( | void |  | ) |

Change the power setting to On.

## ◆ send()

void IRDaikin152::send | ( | const uint16_t | repeat = `kDaikin152DefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setComfort()

void IRDaikin152::setComfort | ( | const bool | on | ) |

Set the Comfort mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setEcono()

void IRDaikin152::setEcono | ( | const bool | on | ) |

Set the Economy mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setFan()

void IRDaikin152::setFan | ( | const uint8_t | fan | ) |

Set the speed of the fan.

Parameters

  [in] | fan | The desired setting.

Note
  1-5 or kDaikinFanAuto or kDaikinFanQuiet

## ◆ setMode()

void IRDaikin152::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setPower()

void IRDaikin152::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setPowerful()

void IRDaikin152::setPowerful | ( | const bool | on | ) |

Set the Powerful (Turbo) mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setQuiet()

void IRDaikin152::setQuiet | ( | const bool | on | ) |

Set the Quiet mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRDaikin152::setRaw | ( | const uint8_t | new_code[] | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.

## ◆ setSensor()

void IRDaikin152::setSensor | ( | const bool | on | ) |

Set the Sensor mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setSwingV()

void IRDaikin152::setSwingV | ( | const bool | on | ) |

Set the Vertical Swing mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setTemp()

void IRDaikin152::setTemp | ( | const uint8_t | temp | ) |

Set the temperature.

Parameters

  [in] | temp | The temperature in degrees celsius.

## ◆ stateReset()

void IRDaikin152::stateReset | ( | void |  | ) |

private

Reset the internal state to a fixed known good state.

## ◆ toCommon()

stdAc::state_t IRDaikin152::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toString()

String IRDaikin152::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRDaikin152::validChecksum | ( | uint8_t | state[],
|  | const uint16_t | length = `kDaikin152StateLength`
| ) |  |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length of the state array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

Daikin152Protocol IRDaikin152::_

private

## ◆ _irsend

IRsend IRDaikin152::_irsend

private

instance of the IR send class

The documentation for this class was generated from the following files:

- src/ir_Daikin.h
- src/ir_Daikin.cpp